﻿@*
    For more information on enabling MVC for empty projects, visit https://go.microsoft.com/fwlink/?LinkID=397860
*@
@{
    var error = TempData["Error"] as string;
    var success = TempData["Success"] as string;
    var userAnswer = TempData["userAnswers"] as List<AuthnData.Classes.UsersAnswers>;
    var users = TempData["accounts"] as List<AuthnData.Classes.Accounts>;
    var sondage = TempData["sondage"] as AuthnData.Classes.Sondages;
    var answers = TempData["answers"] as List<AuthnData.Classes.Answers>;
    var nbTotalVotant = TempData["nbTotalVotant"] as string;
    ViewData["Title"] = "Résultats";
}

@if(!string.IsNullOrEmpty(error))
{
    <h2 class="alert-danger" style="padding:20px;">@error</h2>
}
@if(!string.IsNullOrEmpty(success))
{
    <h2 class="alert-success" style="padding:20px;">@success</h2>
}

@if(userAnswer != null & users != null)
{
    <script>
        let answerCategories = [];
        let answerNumbers = [];
        let iTables = -1;
        let listResults = {};
        @* console.log('@userAnswer'); *@
        
    </script>
    @foreach(var answer in answers) {
        <script>
                iTables++;
                answerCategories[iTables] = '@answer.Content';
        </script>
    }
    <script>
                // intialize array
        for (let i = 0; i < (iTables+1); i++) {
                answerNumbers[i] = 0;
        }
        </script>
    @* ne rentre pas dans le foreach si il n'y a pas eut de réponses sur le sondage *@
@foreach(var result in userAnswer)
{
    var resultats = result.answers.Split(";");
    @foreach(var content in resultats) {  
            <script>

                // hydrate array
                for (let i = 0; i < (iTables+1); i++) {
                    if (answerCategories[i] == '@content') {
                        answerNumbers[i] += 1;
                    }
                }

                // sort arrays in order of the most votes received
                listResults = sortArrays([ answerNumbers, answerCategories]);
                listResults[0].reverse();
                listResults[1].reverse();

                /**
                *  Sorts all arrays together with the first. Pass either a list of arrays, or a map. Any key is accepted.
                *     Array|Object arrays               [sortableArray, ...otherArrays]; {sortableArray: [], secondaryArray: [], ...}
                *     Function comparator(?,?) -> int   optional compareFunction, compatible with Array.sort(compareFunction)
                */
                function sortArrays(arrays, comparator = (a, b) => (a < b) ? -1 : (a > b) ? 1 : 0) {
                    let arrayKeys = Object.keys(arrays);
                    let sortableArray = Object.values(arrays)[0];
                    let indexes = Object.keys(sortableArray);
                    let sortedIndexes = indexes.sort((a, b) => comparator(sortableArray[a], sortableArray[b]));

                    let sortByIndexes = (array, sortedIndexes) => sortedIndexes.map(sortedIndex => array[sortedIndex]);

                    if (Array.isArray(arrays)) {
                        return arrayKeys.map(arrayIndex => sortByIndexes(arrays[arrayIndex], sortedIndexes));
                    } else {
                        let sortedArrays = {};
                        arrayKeys.forEach((arrayKey) => {
                            sortedArrays[arrayKey] = sortByIndexes(arrays[arrayKey], sortedIndexes);
                        });
                        return sortedArrays;
                    }
                }

                if (listResults) {
                    console.log(listResults);
                }

                @* listResults[1][1] = 2; *@
            </script>
        }
}
    <h1>Résultats du Sondage</h1>

    <hr class="form-breaker">

    <div class="result-main-div">
        <div class="reasult-main-graph">
            <div class="result-graph-option-div">
                <select name="affichage-graph" id="" class="form-control" onchange="updateGraphType(this)">
                    <option value="bar-graph" id="bar" selected>Graphique Bar</option>
                    <option value="line-graph" id="line">Graphique line</option>
                    <option value="doughnut-graph" id="doughnut">Graphique doughnut</option>
                    <option value="pie-graph" id="pie">Graphique pie</option>
                </select>
            </div>
            <div class="result-graph-div">
                <canvas id="orderedListGraph" width="320px" height="320px"></canvas>
                <script>
                    @* console.log(listResults); *@
                @foreach(var result in userAnswer)
                {
                    var resultats = result.answers.Split(";");
                    @* <a>@users.Where(c => c.Id == result.accountId).FirstOrDefault().Username : à voter @foreach(var content in resultats) {  @content } le @result.answerDate</a> *@
                    @* @foreach(var content in resultats) {  @content } *@
                }
                const ctx = document.getElementById('orderedListGraph').getContext('2d');
                // généré en fonction du nombre de labels
                let firstGraph = new Chart(ctx, {
                    type: 'bar',
                    data: {
                        labels: listResults[1],
                        datasets: [{
                            label: '# of Votes',
                            data: listResults[0],
                            backgroundColor: [
                                'rgba(255, 99, 132, 0.2)',
                                'rgba(54, 162, 235, 0.2)',
                                'rgba(255, 206, 86, 0.2)',
                                'rgba(75, 192, 192, 0.2)',
                                'rgba(153, 102, 255, 0.2)',
                                'rgba(255, 159, 64, 0.2)'
                            ],
                            borderColor: [
                                'rgba(255, 99, 132, 1)',
                                'rgba(54, 162, 235, 1)',
                                'rgba(255, 206, 86, 1)',
                                'rgba(75, 192, 192, 1)',
                                'rgba(153, 102, 255, 1)',
                                'rgba(255, 159, 64, 1)'
                            ],
                            borderWidth: 1
                        }]
                    },
                    options: {
                        scales: {
                            y: {
                                beginAtZero: true
                            }
                        }
                    }
                });

                function updateGraphType(item) {
                    firstGraph.destroy()
                    @* orderedListGraph.type = item.options[item.selectedIndex].id; *@
                    firstGraph = new Chart(ctx, {
                        type: item.options[item.selectedIndex].id,
                        data: {
                        labels: listResults[1],
                        datasets: [{
                            label: '# of Votes',
                            data: listResults[0],                                backgroundColor: [
                                    'rgba(255, 99, 132, 0.5)',
                                    'rgba(54, 162, 235, 0.5)',
                                    'rgba(255, 206, 86, 0.5)',
                                    'rgba(75, 192, 192, 0.5)',
                                    'rgba(153, 102, 255, 0.5)',
                                    'rgba(255, 159, 64, 0.5)'
                                ],
                                borderColor: [
                                    'rgba(255, 99, 132, 1)',
                                    'rgba(54, 162, 235, 1)',
                                    'rgba(255, 206, 86, 1)',
                                    'rgba(75, 192, 192, 1)',
                                    'rgba(153, 102, 255, 1)',
                                    'rgba(255, 159, 64, 1)'
                                ],
                                borderWidth: 1
                            }]
                        },
                        options: {
                            legend: {
                                label: {
                                    fontColor: "blue",
                                    fontSize: 18
                                }
                            },
                            scales: {
                                y: {
                                    beginAtZero: true
                                }
                            }
                        }
                    });
                    @* if(item.options[item.selectedIndex].id) alert('changed graph'); *@
                }
                </script>
            </div>
        </div>
        <div class="form-breaker-vertical-responsif"></div>
        <div class="result-answer-div">
            <h2 class="do-not-overflow-plz">@sondage.Question</h2>
            <hr class="form-breaker">
            <h4>Au total @nbTotalVotant personnes ont voté sur ce sondage</h4>
            <hr class="form-breaker">
            <div id="result-custom-container">
                @foreach(var answer in answers) {
                    <div class="anser-category">
                        <div class="result-label">
                            <span class="result-label-text"></span>
                        </div>
                        <div class="result-percent-container">
                            <span class="result-percent-text"></span>
                            <div class="result-100-percent">
                                <div class="result-percent"></div>
                            </div>
                        </div>
                    </div>
                <hr class="form-breaker">
                }
            </div>
            @* @foreach(var result in userAnswer)
            {
                var resultats = result.answers.Split(";");
                <a>@users.Where(c => c.Id == result.accountId).FirstOrDefault().Username : à voter @foreach(var content in resultats) {  @content } le @result.answerDate</a>
                @foreach(var content in resultats) {  @content }
            } *@
        </div>
    </div>
    <script>
        let labels = document.querySelectorAll('[class="result-label-text"]');
        let resultPercent = document.querySelectorAll('[class="result-percent"]');
        let resultPercentText = document.querySelectorAll('[class="result-percent-text"]');

        let totalVotes = 0
        for (let i = 0; i < listResults[0].length; i++) {
            totalVotes += listResults[0][i];
        }

        // dynamicly set the results in the right divs
        for (let i = 0; i < listResults[1].length; i++) {
            let percent = (listResults[0][i]/totalVotes)*100;
            labels[i].innerHTML = listResults[1][i];
            resultPercent[i].setAttribute("style", ("width:"+percent+"%;"));
            resultPercentText[i].innerHTML = Math.round(percent * 100) / 100+"%";
        }
    </script>

}